diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1f272c69..784490c3 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -12,6 +12,11 @@ require "hive/daemon/concurrency_controller"
 require "hive/daemon/child_supervisor"
 require "hive/daemon/status_consumer"
 require "hive/daemon/stale_agent_healer"
+require "hive/daemon/auto_retry_health"
+require "hive/daemon/recoverable_marker_retry"
+require "hive/marker_recovery"
+require "hive/markers"
+require "hive/task"
 require "hive/daemon/display_name_backfiller"
 require "hive/daemon/task_id_backfiller"
 require "hive/daemon/dispatch_request_queue"
@@ -89,6 +94,7 @@ module Hive
         @shutdown_grace_sec = @daemon_cfg.fetch("shutdown_grace_sec", 600)
         @poll_interval_sec = @daemon_cfg.fetch("poll_interval_sec", 30)
         @fast_poll_sec = @daemon_cfg.fetch("fast_poll_sec", 1)
+        @auto_retry_enabled = auto_retry_enabled?
         # Grace window for AGENT_WORKING markers with no PID attribute
         # (placeholders stamped on stage entry). Within this window the
         # dispatcher is presumed to be mid-spawn; past it, the marker
@@ -103,8 +109,10 @@ module Hive
         @stale_agent_healer = StaleAgentHealer.new(
           controller: @controller,
           logger: @logger,
-          grace_sec: agent_marker_grace_sec
+          grace_sec: agent_marker_grace_sec,
+          auto_retry_enabled: @auto_retry_enabled
         )
+        rebuild_recoverable_retry!
         # Additive self-heal for tasks whose one-shot name generation at
         # `hive new` never landed (agent/codex outage). Re-spawns
         # `hive generate-name <folder>` on later ticks; never touches
@@ -269,6 +277,12 @@ module Hive
                         keeping_previous: true)
         end
 
+        # Dependency-health recovery intentionally runs after stale liveness
+        # reconciliation (so it sees a stable terminal marker) and before the
+        # ordinary row dispatch.  It only stages normal queue requests; no
+        # second dispatcher state machine is introduced here.
+        run_recoverable_marker_retry(result.rows, now: now) if @auto_retry_enabled
+
         # Self-heal tasks left showing their raw slug because name
         # generation never landed at `hive new`. Purely additive and
         # marker-free, so order relative to dispatch is irrelevant — but
@@ -1259,6 +1273,75 @@ module Hive
       #   7. Spawn via `dispatch_command`, threading `request_id`
       #      through the supervisor so `reap_completed` can unlink the
       #      file and log `:dispatch_request_completed`.
+      # Evaluate parked terminal errors and stage the normal same-stage queue
+      # command before clearing the exact marker.  A queue write failure leaves
+      # the marker untouched; a clear race removes the staged request.
+      def run_recoverable_marker_retry(rows, now:)
+        rows.each do |row|
+          next unless row.marker.to_s == "error"
+          next if @controller.running_task?(project: row.project, slug: row.slug)
+
+          decision = @recoverable_marker_retry.decide(row, now: now)
+          next unless decision.approved?
+
+          request_id = Hive::Daemon::DispatchRequestQueue.write_request!(
+            project: row.project, slug: row.slug, argv: recovery_argv(row),
+            requestor: "healer", trigger: "dependency_health_recovery",
+            recovery: {
+              task_id: row.task_id, stage: row.stage,
+              marker_id: decision.candidate.marker_id, reason: decision.candidate.reason,
+              attempt: decision.attempt
+            },
+            state_home: dispatch_request_state_home, now: now
+          )
+          task = Hive::Task.new(row.folder)
+          cleared = Hive::MarkerRecovery.new.clear!(
+            task: task, expected_name: :error,
+            match_attrs: { "marker_id" => decision.candidate.marker_id, "reason" => decision.candidate.reason },
+            action: "auto retry #{decision.candidate.reason}", details: decision.audit
+          )
+          unless cleared
+            Hive::Daemon::DispatchRequestQueue.remove_if_unclaimed(request_id, state_home: dispatch_request_state_home)
+            @logger.event(:marker_recovery, **decision.audit.merge(action: "race_lost", request_id: request_id))
+            next
+          end
+
+          @recoverable_marker_retry.record_recovery(row, decision, now: now)
+          @logger.event(:marker_recovery, **decision.audit.merge(action: "requeued", request_id: request_id))
+        rescue StandardError => e
+          @logger.event(:marker_recovery,
+                        project: row.project, slug: row.slug, stage: row.stage,
+                        action: "failed", error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def recovery_argv(row)
+        if Hive::Workflows.coding_row?(row) && row.stage.to_s == "3-plan"
+          [ "hive", "plan", row.slug, "--project", row.project, "--from", "3-plan" ]
+        else
+          [ "hive", "run", row.slug, "--project", row.project, "--stage", row.stage ]
+        end
+      end
+
+      def auto_retry_enabled?
+        value = @daemon_cfg.dig("auto_retry", "enabled")
+        value.nil? ? true : value == true
+      end
+
+      def rebuild_recoverable_retry!
+        @recoverable_health = Hive::Daemon::AutoRetryHealth.new
+        classifier = Hive::Daemon::RecoverableFailure.new(provider_resolver: lambda { |row|
+          explicit = row.marker_attrs["provider"].to_s
+          next explicit unless explicit.empty?
+
+          project = Hive::Config.find_project(row.project)
+          project && Hive::Config.load(project.fetch("path")).dig("execute", "agent")
+        })
+        @recoverable_marker_retry = Hive::Daemon::RecoverableMarkerRetry.new(
+          classifier: classifier, health: @recoverable_health, logger: @logger
+        )
+      end
+
       def process_dispatch_requests(now:)
         pending = Hive::Daemon::DispatchRequestQueue.pending(
           state_home: dispatch_request_state_home,
@@ -1325,6 +1408,11 @@ module Hive
           return
         end
 
+        if req.recovery && !recovery_request_valid?(req)
+          reject_request(req, reason: "recovery_identity_changed")
+          return
+        end
+
         # C4 from PR #241 ce-code-review: gate on project_enabled? so a
         # disabled project's queued requests don't dispatch. The
         # auto-advance path (handle_row) already does this; the
@@ -1404,6 +1492,26 @@ module Hive
         raise
       end
 
+      # A dependency-recovery request is intentionally durable beyond the
+      # generic ten-minute queue expiry. It is runnable only while the task is
+      # still markerless in the exact stage and identity that the recovery
+      # decision cleared; any stage/marker/manual change invalidates it.
+      def recovery_request_valid?(req)
+        identity = req.recovery
+        project = Hive::Config.find_project(req.project)
+        return false unless project && identity.is_a?(Hash)
+
+        root = project.fetch("path")
+        folder = File.join(root, ".hive-state", "stages", identity.fetch("stage"), req.slug)
+        task = Hive::Task.new(folder)
+        return false unless task.id.to_s == identity.fetch("task_id").to_s
+        return false unless "#{task.stage_index}-#{task.stage_name}" == identity.fetch("stage")
+
+        Hive::Markers.current(task.state_file).none?
+      rescue KeyError, Hive::Error, SystemCallError, ArgumentError
+        false
+      end
+
       def preclaim_dispatch_request(req, now:)
         claimed = Hive::Daemon::DispatchRequestQueue.claim(
           req.request_id, pid: nil, process_start_time: nil,
@@ -1804,6 +1912,7 @@ module Hive
         @shutdown_grace_sec = @daemon_cfg.fetch("shutdown_grace_sec", 600)
         @poll_interval_sec = @daemon_cfg.fetch("poll_interval_sec", 30)
         @fast_poll_sec = @daemon_cfg.fetch("fast_poll_sec", 1)
+        @auto_retry_enabled = auto_retry_enabled?
         # R-02: push reloaded child-timeout knobs into the supervisor so
         # an operator tuning daemon.child_timeout_sec / verb overrides via
         # SIGHUP takes effect for children spawned after the reload.
@@ -1829,8 +1938,10 @@ module Hive
           grace_sec: @daemon_cfg.fetch(
             "agent_marker_grace_sec",
             Hive::TaskAction::DEFAULT_AGENT_MARKER_GRACE_SEC
-          )
+          ),
+          auto_retry_enabled: @auto_retry_enabled
         )
+        rebuild_recoverable_retry!
         # Rebuild alongside the healer on SIGHUP reload so a future
         # operator-tunable knob (e.g. max_per_tick) would take effect
         # within one tick; today it carries only the dry_run flag.
diff --git a/lib/hive/daemon/logger.rb b/lib/hive/daemon/logger.rb
index 6af59dc9..51e0a78e 100644
--- a/lib/hive/daemon/logger.rb
+++ b/lib/hive/daemon/logger.rb
@@ -76,6 +76,9 @@ module Hive
         digest_state_unreadable
         answer_digest_failure_backoff
         answer_digest_state_unreadable
+        auto_retry_failure_observed
+        auto_retry_decision
+        marker_recovery
         fatal
       ].freeze
 
diff --git a/lib/hive/daemon/recoverable_failure.rb b/lib/hive/daemon/recoverable_failure.rb
new file mode 100644
index 00000000..c4123971
--- /dev/null
+++ b/lib/hive/daemon/recoverable_failure.rb
@@ -0,0 +1,147 @@
+require "digest"
+require "time"
+
+module Hive
+  module Daemon
+    # Closed classifier for terminal failures that may be retried after their
+    # external dependency becomes healthy.  This deliberately does not expose
+    # a generic `recoverable?` predicate: callers must keep the refusal code
+    # when they decide to park a task.
+    class RecoverableFailure
+      LEGACY_LOG_MAX_BYTES = 64 * 1024
+      LEGACY_LOG_MAX_AGE_SEC = 24 * 60 * 60
+      CODEX_AUTH_DIAGNOSTIC = "codex_auth_401".freeze
+      CODEX_AUTH_MESSAGE = "Codex authentication failed (HTTP 401; missing bearer/basic authentication)".freeze
+
+      # Messages emitted by Hive::ClaudeLauncher / Stages::Base.  These are
+      # intentionally patterns for the stable, production-owned prefixes,
+      # not a catch-all for Hive::AgentError.
+      CLAUDE_LAUNCH_PATTERNS = [
+        /\Atmux session .+ already exists;/,
+        /\Atmux session .+ did not start\z/,
+        /\Aclaude tmux session .+ terminated before becoming ready /,
+        /\Aclaude interactive prompt did not become ready /,
+        /\Acould not inspect claude tmux session /,
+        /\Atmux not runnable:/,
+        /\Atmux binary not runnable:/,
+        /\Acould not parse tmux -V output:/,
+        /\Atmux \d+(?:\.\d+)? below minimum /,
+        /\Apreflight failed: /
+      ].freeze
+      CODING_STAGES = %w[2-brainstorm 3-plan 4-execute].freeze
+
+      Candidate = Struct.new(
+        :marker_id, :reason, :stage, :diagnostic_kind, :evidence_source,
+        :task_id, :task_folder, :worktree_path, :evidence,
+        keyword_init: true
+      )
+      Refusal = Struct.new(:code, :message, keyword_init: true)
+
+      def initialize(provider_resolver: nil, now: -> { Time.now })
+        @provider_resolver = provider_resolver || ->(row) { row.marker_attrs["provider"] }
+        @now = now
+      end
+
+      def classify(row)
+        return refusal("not_terminal_error") unless row.marker.to_s == "error"
+
+        case row.marker_attrs["reason"].to_s
+        when "implementer_failed" then classify_codex(row)
+        when "claude_launch_failed" then classify_claude(row)
+        else refusal("unsupported_reason")
+        end
+      rescue StandardError => e
+        refusal("classifier_error", e.class.name)
+      end
+
+      def self.codex_auth_401_text?(text)
+        value = text.to_s
+        return false unless value.match?(/\b(?:HTTP\s*)?401\b/i)
+
+        value.match?(/(?:missing|required)\s+(?:bearer(?:\s+token)?|basic\s+authentication)/i)
+      end
+
+      def self.claude_launch_message?(message)
+        CLAUDE_LAUNCH_PATTERNS.any? { |pattern| pattern.match?(message.to_s) }
+      end
+
+      private
+
+      def classify_codex(row)
+        return refusal("unsupported_stage") unless row.stage.to_s == "4-execute"
+        return refusal("provider_not_codex") unless @provider_resolver.call(row).to_s == "codex"
+
+        attrs = row.marker_attrs
+        if attrs["diagnostic"] == CODEX_AUTH_DIAGNOSTIC && self.class.codex_auth_401_text?(attrs["message"])
+          return candidate(row, CODEX_AUTH_DIAGNOSTIC, "marker", attrs["message"])
+        end
+
+        legacy = legacy_codex_evidence(row)
+        return refusal("codex_auth_signature_missing") unless legacy
+
+        candidate(row, CODEX_AUTH_DIAGNOSTIC, "execute_impl_log", legacy)
+      end
+
+      def classify_claude(row)
+        return refusal("unsupported_stage") unless CODING_STAGES.include?(row.stage.to_s)
+        return refusal("exception_class_mismatch") unless row.marker_attrs["exception_class"].to_s == "Hive::AgentError"
+        return refusal("claude_launch_signature_missing") unless self.class.claude_launch_message?(row.marker_attrs["message"])
+
+        candidate(row, "claude_launch", "marker", row.marker_attrs["message"])
+      end
+
+      def candidate(row, kind, source, evidence)
+        marker_id = row.marker_attrs["marker_id"].to_s
+        return refusal("marker_id_missing") if marker_id.empty?
+
+        Candidate.new(
+          marker_id: marker_id,
+          reason: row.marker_attrs["reason"].to_s,
+          stage: row.stage.to_s,
+          diagnostic_kind: kind,
+          evidence_source: source,
+          task_id: row.respond_to?(:task_id) ? row.task_id : nil,
+          task_folder: row.folder,
+          worktree_path: row.respond_to?(:worktree_path) ? row.worktree_path : nil,
+          evidence: evidence.to_s.byteslice(0, 512).to_s
+        )
+      end
+
+      def refusal(code, message = nil)
+        Refusal.new(code: code, message: message)
+      end
+
+      # Legacy v0 markers only have reason/status/message.  They are eligible
+      # only when one current execute log is safely contained in the task log
+      # directory, fresh relative to the marker, and carries the exact
+      # signature.  A symlink, multiple equally-new logs, stale output, or an
+      # oversized file makes the answer a hard no.
+      def legacy_codex_evidence(row)
+        return nil unless row.folder && row.state_file && File.file?(row.state_file)
+        hive_state = File.dirname(File.dirname(File.dirname(row.folder)))
+        root = File.expand_path(File.join(hive_state, "logs", row.slug.to_s))
+        return nil unless File.directory?(root)
+        return nil if File.symlink?(root)
+
+        logs = Dir.glob(File.join(root, "execute-impl-*.log")).filter_map do |path|
+          next unless File.file?(path) && !File.symlink?(path)
+          next unless File.realpath(path).start_with?(File.realpath(root) + File::SEPARATOR)
+          next if File.size(path) > LEGACY_LOG_MAX_BYTES
+          next if @now.call - File.mtime(path) > LEGACY_LOG_MAX_AGE_SEC
+          next if row.state_file_mtime && File.mtime(path) < row.state_file_mtime
+
+          [ path, File.mtime(path) ]
+        rescue SystemCallError
+          nil
+        end
+        return nil unless logs.size == 1
+
+        File.read(logs.first.first, LEGACY_LOG_MAX_BYTES).then do |text|
+          self.class.codex_auth_401_text?(text) ? text : nil
+        end
+      rescue SystemCallError, IOError
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/recoverable_marker_retry.rb b/lib/hive/daemon/recoverable_marker_retry.rb
new file mode 100644
index 00000000..1d6e3724
--- /dev/null
+++ b/lib/hive/daemon/recoverable_marker_retry.rb
@@ -0,0 +1,249 @@
+require "json"
+require "time"
+require "yaml"
+require "hive/events"
+require "hive/git_ops"
+require "hive/lock"
+require "hive/markers"
+require "hive/worktree"
+require "hive/daemon/recoverable_failure"
+
+module Hive
+  module Daemon
+    # Policy coordinator for automatic recovery.  It never clears a marker;
+    # that mutation belongs to MarkerRecovery after this object returns an
+    # approved decision.  Every uncertainty is represented as a refusal.
+    class RecoverableMarkerRetry
+      MAX_ATTEMPTS = 2
+      SECOND_ATTEMPT_DELAY_SEC = 30 * 60
+      NEGATIVE_AUDIT_INTERVAL_SEC = 30 * 60
+
+      Decision = Struct.new(:action, :code, :message, :candidate, :bundle, :attempt,
+                            :fingerprint, :baseline_fingerprint, :audit, keyword_init: true) do
+        def approved?
+          action == :approved
+        end
+      end
+
+      def initialize(classifier: RecoverableFailure.new, health:, logger:, config_loader: Hive::Config.method(:load),
+                     project_root_resolver: nil, event_emitter: Hive::Events, clock: -> { Time.now }, git_ops: Hive::GitOps,
+                     commit_events: true)
+        @classifier = classifier
+        @health = health
+        @logger = logger
+        @config_loader = config_loader
+        @project_root_resolver = project_root_resolver || method(:default_project_root)
+        @event_emitter = event_emitter
+        @clock = clock
+        @git_ops = git_ops
+        @commit_events = commit_events == true
+      end
+
+      def decide(row, now: @clock.call)
+        classification = @classifier.classify(row)
+        return refuse(row, classification.code, classification.message, now: now) unless classification.is_a?(RecoverableFailure::Candidate)
+
+        safety = safety_refusal(row, classification)
+        return refuse(row, safety, now: now, candidate: classification) if safety
+
+        bundle = @health.bundle_for(row, classification)
+        return refuse(row, "health_unhealthy", now: now, candidate: classification, bundle: bundle) unless bundle&.healthy
+
+        ledger = read_ledger(row)
+        return refuse(row, "ledger_malformed", now: now, candidate: classification, bundle: bundle) unless ledger
+
+        baseline = observe_failure_once(row, classification, bundle, ledger, now: now)
+        return refuse(row, "failure_observation_unwritable", now: now, candidate: classification, bundle: bundle) unless baseline
+
+        attempts = ledger.fetch(:attempts)
+        if attempts >= MAX_ATTEMPTS
+          return refuse(row, "retry_budget_exhausted", now: now, candidate: classification, bundle: bundle,
+                        attempt: attempts, baseline: baseline, force_audit: true)
+        end
+        if attempts == 1 && now - ledger.fetch(:last_retry_at) < SECOND_ATTEMPT_DELAY_SEC
+          return refuse(row, "second_attempt_backoff", now: now, candidate: classification, bundle: bundle,
+                        attempt: 2, baseline: baseline)
+        end
+        if attempts == 1 && bundle.fingerprint == baseline
+          return refuse(row, "second_attempt_signal_unchanged", now: now, candidate: classification, bundle: bundle,
+                        attempt: 2, baseline: baseline)
+        end
+
+        Decision.new(action: :approved, code: "eligible", message: "all recovery gates passed",
+                     candidate: classification, bundle: bundle, attempt: attempts + 1,
+                     fingerprint: bundle.fingerprint, baseline_fingerprint: baseline, audit: audit_payload(
+                       row, classification, bundle, attempts + 1, "approved", "eligible", now
+                     ))
+      rescue StandardError => e
+        refuse(row, "policy_error", "#{e.class}: #{e.message}", now: now)
+      end
+
+      # Called only after MarkerRecovery has atomically staged and cleared the
+      # exact marker.  This is the durable success ledger entry.
+      def record_recovery(row, decision, now: @clock.call, action: "reenqueue")
+        return false unless decision.approved?
+
+        payload = audit_payload(row, decision.candidate, decision.bundle, decision.attempt, action, "eligible", now)
+        emit_task_event(row, :auto_retry_decision, payload)
+        @logger.event(:auto_retry_decision, **payload)
+        true
+      rescue StandardError
+        false
+      end
+
+      private
+
+      def default_project_root(row)
+        project = Hive::Config.find_project(row.project)
+        raise Hive::ConfigError, "unknown project #{row.project.inspect}" unless project
+
+        project.fetch("path")
+      end
+
+      def safety_refusal(row, candidate)
+        current = Hive::Markers.current(row.state_file)
+        return "marker_not_current" unless current.name == :error && current.attrs["reason"] == candidate.reason
+        return "marker_identity_changed" unless candidate.marker_id.to_s == current.attrs["marker_id"].to_s
+        return "live_stage_owner" if row.live_task_lock == true || File.exist?(File.join(row.folder, ".lock"))
+        return "terminal_success_present" if %i[complete execute_complete review_complete].include?(current.name)
+
+        case candidate.stage
+        when "4-execute" then execute_safety(row)
+        when "2-brainstorm" then brainstorm_safety(row)
+        when "3-plan" then plan_safety(row)
+        else "unsupported_stage"
+        end
+      rescue SystemCallError, Hive::Error
+        "safety_check_error"
+      end
+
+      def execute_safety(row)
+        return "worktree_path_missing" if row.worktree_path.to_s.empty?
+        root = @config_loader.call(@project_root_resolver.call(row))["worktree_root"] ||
+               Hive::Worktree.default_worktree_root(File.basename(@project_root_resolver.call(row)))
+        pointer = Hive::Worktree.read_pointer(row.folder)
+        return "worktree_pointer_missing" unless pointer.is_a?(Hash) && pointer["path"] == row.worktree_path
+
+        resolved = Hive::Worktree.validate_pointer_path(pointer.fetch("path"), root)
+        return "worktree_pointer_mismatch" unless resolved == File.realpath(row.worktree_path)
+        return "dirty_worktree" unless @git_ops.new(resolved).status_short.strip.empty?
+
+        nil
+      end
+
+      def brainstorm_safety(row)
+        path = File.join(row.folder, "brainstorm.md")
+        return nil unless File.exist?(path)
+
+        # An unanswered Q&A scaffold has blank A-lines. Any non-empty answer
+        # or non-scaffold prose is user work and must stay parked.
+        body = File.read(path, encoding: "UTF-8")
+        return nil if body.strip.empty? || body.match?(/\A(?:\s*#+\s*(?:Round|Q\d+|A\d+).*|<!--.*?-->)*\s*\z/m)
+        return "brainstorm_answered" if body.match?(/^###\s*A\d+\.\s*\S/m)
+
+        "brainstorm_substantive"
+      end
+
+      def plan_safety(row)
+        path = File.join(row.folder, "plan.md")
+        return nil unless File.exist?(path)
+
+        body = File.read(path, encoding: "UTF-8").strip
+        return nil if body.empty? || body.match?(/\A(?:<!--[^>]*-->\s*)+\z/m)
+
+        "plan_substantive"
+      end
+
+      def read_ledger(row)
+        path = File.join(row.folder, "events.jsonl")
+        return blank_ledger unless File.exist?(path)
+
+        records = File.readlines(path, chomp: true).reject(&:empty?).map { |line| JSON.parse(line) }
+        key = task_key(row)
+        relevant = records.select { |record| record["details"].is_a?(Hash) && record["details"]["task_key"] == key }
+        attempts = relevant.count { |record| record["event_type"] == "auto_retry_decision" && record.dig("details", "action") == "reenqueue" }
+        last_retry = relevant.reverse.find { |record| record["event_type"] == "auto_retry_decision" && record.dig("details", "action") == "reenqueue" }
+        observations = relevant.select { |record| record["event_type"] == "auto_retry_failure_observed" }
+        negatives = relevant.select { |record| record["event_type"] == "auto_retry_decision" && record.dig("details", "action") == "parked" }
+        {
+          attempts: attempts,
+          last_retry_at: last_retry ? Time.parse(last_retry.fetch("ts")) : Time.at(0),
+          observations: observations,
+          negatives: negatives
+        }
+      rescue JSON::ParserError, KeyError, ArgumentError, SystemCallError
+        nil
+      end
+
+      def blank_ledger
+        { attempts: 0, last_retry_at: Time.at(0), observations: [], negatives: [] }
+      end
+
+      def observe_failure_once(row, candidate, bundle, ledger, now:)
+        current = ledger[:observations].reverse.find { |record| record.dig("details", "marker_id") == candidate.marker_id }
+        return current.dig("details", "baseline_fingerprint") if current
+
+        payload = audit_payload(row, candidate, bundle, ledger[:attempts] + 1, "observed", "failure_observed", now).merge(
+          "baseline_fingerprint" => bundle.fingerprint
+        )
+        return nil unless emit_task_event(row, :auto_retry_failure_observed, payload)
+
+        @logger.event(:auto_retry_failure_observed, **payload)
+        bundle.fingerprint
+      end
+
+      def refuse(row, code, message = nil, now:, candidate: nil, bundle: nil, attempt: nil, baseline: nil, force_audit: false)
+        payload = audit_payload(row, candidate, bundle, attempt, "parked", code, now).merge("message" => message)
+        ledger = read_ledger(row)
+        should_audit = force_audit || ledger.nil? || negative_audit_due?(ledger, payload, now)
+        if should_audit
+          emit_task_event(row, :auto_retry_decision, payload)
+          @logger.event(:auto_retry_decision, **payload)
+        end
+        Decision.new(action: :refused, code: code, message: message, candidate: candidate, bundle: bundle,
+                     attempt: attempt, fingerprint: bundle&.fingerprint, baseline_fingerprint: baseline, audit: payload)
+      end
+
+      def negative_audit_due?(ledger, payload, now)
+        prior = ledger[:negatives].reverse.find do |record|
+          details = record["details"]
+          details["rationale"] == payload["rationale"] && details["health_fingerprint"] == payload["health_fingerprint"]
+        end
+        return true unless prior
+
+        now - Time.parse(prior.fetch("ts")) >= NEGATIVE_AUDIT_INTERVAL_SEC
+      rescue ArgumentError, KeyError
+        true
+      end
+
+      def audit_payload(row, candidate, bundle, attempt, action, rationale, now)
+        {
+          task_key: task_key(row), task_id: (row.respond_to?(:task_id) ? row.task_id : nil), slug: row.slug,
+          stage: row.stage, marker_id: candidate&.marker_id, reason: candidate&.reason || row.marker_attrs["reason"],
+          diagnostic_kind: candidate&.diagnostic_kind, probe_summaries: bundle&.probes&.map(&:summary) || [],
+          health_fingerprint: bundle&.fingerprint, attempt: attempt, action: action, rationale: rationale,
+          timestamp: now.utc.iso8601
+        }
+      end
+
+      def task_key(row)
+        [ row.project, row.respond_to?(:task_id) ? row.task_id : nil, row.slug ].join(":")
+      end
+
+      def emit_task_event(row, type, details)
+        event = @event_emitter.emit(task_folder: row.folder, slug: row.slug, stage: row.stage,
+                                    event_type: type, message: details["rationale"], details: details)
+        return nil unless event
+        return event unless @commit_events
+
+        hive_state = File.dirname(File.dirname(File.dirname(row.folder)))
+        Hive::Lock.with_commit_lock(hive_state) do
+          @git_ops.new(@project_root_resolver.call(row)).hive_commit(
+            stage_name: row.stage, slug: row.slug, action: "#{type}"
+          )
+        end
+        event
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/stale_agent_healer.rb b/lib/hive/daemon/stale_agent_healer.rb
index 02042f78..79a0bd21 100644
--- a/lib/hive/daemon/stale_agent_healer.rb
+++ b/lib/hive/daemon/stale_agent_healer.rb
@@ -115,13 +115,14 @@ module Hive
       def initialize(controller:, logger:, grace_sec: 300,
                      review_error_auto_recovery_limit: REVIEW_ERROR_AUTO_RECOVERY_LIMIT,
                      error_auto_recovery_limit: ERROR_AUTO_RECOVERY_LIMIT,
-                     request_queue: Hive::Daemon::DispatchRequestQueue)
+                     request_queue: Hive::Daemon::DispatchRequestQueue, auto_retry_enabled: true)
         @controller = controller
         @logger = logger
         @request_queue = request_queue
         @grace_sec = grace_sec
         @review_error_auto_recovery_limit = review_error_auto_recovery_limit
         @error_auto_recovery_limit = error_auto_recovery_limit
+        @auto_retry_enabled = auto_retry_enabled == true
         @review_error_auto_recoveries = Hash.new(0)
         @error_auto_recoveries = Hash.new(0)
         @review_error_recovery_exhausted = {}
@@ -148,11 +149,13 @@ module Hive
           next if @controller.running_task?(project: row.project, slug: row.slug)
 
           if row.marker.to_s == "review_error"
+            next unless @auto_retry_enabled
             heal_review_error_if_auto_recoverable(row, now: now)
             next
           end
 
           if row.marker.to_s == "error"
+            next unless @auto_retry_enabled
             heal_error_if_auto_recoverable(row, now: now)
             next
           end
diff --git a/lib/hive/daemon/status_consumer.rb b/lib/hive/daemon/status_consumer.rb
index b483ad0a..28925180 100644
--- a/lib/hive/daemon/status_consumer.rb
+++ b/lib/hive/daemon/status_consumer.rb
@@ -16,7 +16,8 @@ module Hive
       # the runner has written its claude_pid to the lock. The daemon
       # healer and dispatcher both need this so they don't race the runner
       # during the pre-claude window (issue #144).
-      Row = Struct.new(:project, :slug, :stage, :workflow, :marker, :marker_attrs, :folder, :state_file,
+      Row = Struct.new(:project, :slug, :task_id, :stage, :workflow, :marker, :marker_attrs, :folder, :state_file,
+                       :worktree_path,
                        :state_file_mtime, :action, :suggested_command, :claude_pid_alive,
                        :live_task_lock, :diagnostic, :depends_on, :blocked_by,
                        :dependency_stage, :blocked,
@@ -181,12 +182,14 @@ module Hive
             rows << Row.new(
               project: project,
               slug: task["slug"],
+              task_id: task["id"],
               stage: task["stage"],
               workflow: task["workflow"],
               marker: task["marker"],
               marker_attrs: task["attrs"].is_a?(Hash) ? task["attrs"] : {},
               folder: task["folder"],
               state_file: task["state_file"],
+              worktree_path: task["worktree_path"],
               state_file_mtime: parse_mtime(task["mtime"], task["state_file"]),
               action: task["action"],
               suggested_command: task["suggested_command"],
